Summary:		User interface to the TELNET protocol
Name:			telnet
Version:		0.17
Release:		5%{?dist}
License:		BSD
URL:			http://web.archive.org/web/20070819111735/www.hcs.harvard.edu/~dholland/computers/old-netkit.html
Source0:		ftp://ftp.uk.linux.org/pub/linux/Networking/netkit/netkit-%{name}-%{version}.tar.gz
# Packaged with telnet client and libtelnet from OpenBSD
# telnet client: https://cvsweb.openbsd.org/cgi-bin/cvsweb/src/usr.bin/telnet/
#     libtelnet: https://cvsweb.openbsd.org/cgi-bin/cvsweb/src/lib/libtelnet/
Source1:		telnet-client.tar.gz
Source2:		telnet@.service
Source3:		telnet.socket

# https://cvsweb.openbsd.org/cgi-bin/cvsweb/src/usr.bin/telnet/Makefile.diff?r1=1.8&r2=1.10
# https://cvsweb.openbsd.org/cgi-bin/cvsweb/src/usr.bin/telnet/commands.c.diff?r1=1.20&r2=1.34
# https://cvsweb.openbsd.org/cgi-bin/cvsweb/src/usr.bin/telnet/externs.h.diff?r1=1.4&r2=1.5
# https://cvsweb.openbsd.org/cgi-bin/cvsweb/src/usr.bin/telnet/main.c.diff?r1=1.7&r2=1.10
# https://cvsweb.openbsd.org/cgi-bin/cvsweb/src/usr.bin/telnet/sys_bsd.c.diff?r1=1.6&r2=1.8
# https://cvsweb.openbsd.org/cgi-bin/cvsweb/src/usr.bin/telnet/telnet.c.diff?r1=1.6&r2=1.11
# https://cvsweb.openbsd.org/cgi-bin/cvsweb/src/usr.bin/telnet/telnet_locl.h.diff?r1=1.1&r2=1.2
# https://cvsweb.openbsd.org/cgi-bin/cvsweb/src/lib/libtelnet/Attic/kerberos.c.diff?r1=1.1&r2=1.5
# https://cvsweb.openbsd.org/cgi-bin/cvsweb/src/usr.bin/telnet/telnet.1.diff?r1=1.14&r2=1.27
# Patch0001 integrated the upstream patches above
Patch0001:		telnet-client-cvs.patch
Patch3000:		telnetd-0.17-pty_read.patch
Patch3001:		telnet-0.17-pek.patch
Patch3002:		telnet-0.17-env.patch
Patch3003:		telnet-0.17-issue.patch
Patch3004:		telnet-0.17-sa-01-49.patch
Patch3005:		telnet-0.17-8bit.patch
Patch3006:		telnet-0.17-argv.patch
Patch3007:		telnet-0.17-conf.patch
Patch3008:		telnet-0.17-cleanup_race.patch
Patch3009:		telnet-0.17-CAN-2005-468_469.patch
Patch3010:		telnet-0.17-errno_test_sys_bsd.patch
Patch3011:		telnet-0.17-force-ipv6-ipv4.patch
Patch3012:		telnet-0.17-overflow-exploit.patch
Patch3013:		telnet-0.17-pty-retry.patch
Patch3014:		netkit-telnet-0.17-ipv6.diff
Patch3015: 		netkit-telnet-0.17-nodns.patch
Patch3016: 		netkit-telnet-0.17-reallynodns.patch
Patch3017: 		netkit-telnet-0.17-core-dump.patch
Patch3018:		netkit-telnet-0.17-gcc7.patch
Patch3019:		netkit-telnet-0.17-manpage.patch
Patch3020:	 	netkit-telnet-0.17-telnetrc.patch
Patch3021:	 	telnet-gethostbyname.patch
Patch3022:	 	telnet-rh678324.patch
Patch3023:	 	telnet-rh674942.patch
Patch3024:	 	telnet-rh704604.patch
Patch3025:	 	telnet-rh825946.patch
Patch3026:	 	telnet-log-address.patch

BuildRequires:	make gcc gcc-c++ perl-interpreter
BuildRequires:	ncurses-devel systemd

%description
The telnet command is used to communicate with another host using the 
TELNET protocol.  If telnet is invoked without the host argument, it 
enters command mode, indicated by its prompt (telnet>). In this mode,
it accepts and executes the commands listed below.  If it is invoked 
with arguments, it performs an open command with those arguments.

%package server
Summary:		The TELNET protocol server
Requires:		systemd
%{?systemd_requires}

%description server
The telnetd program is a server which supports the DARPA telnet 
interactive communication protocol.Telnetd is normally invoked by 
the internet server (see inetd(8)) for requests to connect to the
telnet port as indicated by the /etc/services file (see services(5)).  

%prep
%setup -q -n netkit-%{name}-%{version}
# remove netkit telnet client
mv telnet telnet-netkit
%setup -T -D -q -a 1 -n netkit-%{name}-%{version}
%autopatch -p0 -m 0001 -M 3001
%autopatch -p1 -m 3002 -M 3026

%build
export CFLAGS="$CFLAGS -fpie"
export LDFLAGS="$LDFLAGS -z now -pie"

sed -i 's/^LDFLAGS.*/LDFLAGS=\$LDFLAGS/' configure

./configure --with-c-compiler=%{__cc} 

sed -i 's/\(install.*\)-s \(.*\)/\1\2/g' \
	./telnet/GNUmakefile \
	./telnetd/Makefile \
	./telnetlogin/Makefile

%make_build

%install
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_mandir}/man1
mkdir -p %{buildroot}%{_mandir}/man5
mkdir -p %{buildroot}%{_mandir}/man8

%make_install INSTALLROOT=%{buildroot} MANDIR=%{_mandir}

install -D -p -m 0644 %SOURCE2 %{buildroot}%{_unitdir}/telnet@.service
install -D -p -m 0644 %SOURCE3 %{buildroot}%{_unitdir}/telnet.socket

%post server
%systemd_post telnet.socket

%preun server
%systemd_preun telnet.socket

%postun server
%systemd_postun_with_restart telnet.socket

%files
%doc README
%{_bindir}/telnet
%{_mandir}/man1/telnet.1*

%files server
%{_unitdir}/*
%{_sbindir}/in.telnetd
%{_mandir}/man5/issue.net.5*
%{_mandir}/man8/in.telnetd.8*
%{_mandir}/man8/telnetd.8*

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.17-5
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.17-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.17-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.17-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Jul 21 2022 Xiaojie Chen <jackxjchen@tencent.com> - 0.17-1
- Initial build
